po = {}

po.list = {
	[1]={
		map = "de_cs2d" ;
		sx = 112 ;
		sy = 112 ;
		x = 0 ;
		y = 0 ;
		size = 32 ;
		shootable = true ;
		maxhp = 200 ;
		health = 0 ;
		explode = true ;
		exrange = 100 ; 
		exdamage = 100 ;
		breakingsound = "materials/wood2.wav" ;
		breakedsound = "materials/burstwood.wav" ;
		imgpath = "gfx/testpo.bmp" ;

			-- Do not change this variables below --

		img = -1 ;
		imgs = -1 ;
	};
	[2]={
		map = "de_cs2d" ;
		sx = 144 ;
		sy = 144 ;
		x = 0 ;
		y = 0 ;
		size = 32 ;
		shootable = false ;
		maxhp = 200 ;
		health = 0 ;
		explode = true ;
		exrange = 100 ; 
		exdamage = 100 ;
		breakingsound = "materials/wood2.wav" ;
		breakedsound = "materials/burstwood.wav" ;
		imgpath = "gfx/testpo.bmp" ;

			-- Do not change this variables below --

		img = -1 ;
		imgs = -1 ;
	};
}

function po.addPo()
	for o = 1, #po.list do
		if po.list[o].map == game("sv_map") then
			po.list[o].x = po.list[o].sx
			po.list[o].y = po.list[o].sy
			po.list[o].health = po.list[o].maxhp
			po.list[o].imgs = image(po.list[o].imgpath,po.list[o].x+3,po.list[o].y+3,0)
			po.list[o].img = image(po.list[o].imgpath,po.list[o].x,po.list[o].y,1)
			imagecolor(po.list[o].imgs,0,0,0)
			imagealpha(po.list[o].imgs,0.7)
			if po.list[o].shootable then
				imagehitzone(po.list[o].img,102,-po.list[o].size/2,-po.list[o].size/2,po.list[o].size,po.list[o].size)
			else
				imagehitzone(po.list[o].img,0,-po.list[o].size/2,-po.list[o].size/2,po.list[o].size,po.list[o].size)
			end
		end
	end
end
po.addPo()

addhook("startround","po.addPo")

addhook("move","po.movePo")
function po.movePo(id,x,y)
	for o = 1, #po.list do
		if po.list[o].health>0 then
			local pox, poy = po.list[o].x, po.list[o].y
			local a = -math.deg (math.atan2( x - pox, y - poy ) )
			local d = math.sqrt((x-pox)^2 + (y-poy)^2)
			if d < ( 15 + po.list[o].size/2 ) then
				local str = d - ( 15 + po.list[o].size/2 ) + 2
				if a > -45 and a < 45 then a = 0 elseif a > 45 and a < 135 then a = 90 elseif a > 135 then a = 180 elseif a < - 45 and a > - 135 then a = -90 elseif a < - 135 then a = -180 end
				dx = po.list[o].x - math.sin(math.rad(a)) * str
				dy = po.list[o].y + math.cos(math.rad(a)) * str
				if tile(math.floor(dx/32), math.floor(dy/32), "walkable") then
					po.list[o].x = dx
					po.list[o].y = dy
					imagepos(po.list[o].imgs,po.list[o].x+3,po.list[o].y+3,0)
					imagepos(po.list[o].img,po.list[o].x,po.list[o].y,0)
				else
					local disx = math.sqrt((x-pox)^2)
					local disy = math.sqrt((y-poy)^2)
					if disx <= po.list[o].size/2 or disy <= po.list[o].size/2 then
						dx = po.list[o].x - math.sin(math.rad(a)) * (po.list[o].size/2+15)
						dy = po.list[o].y + math.cos(math.rad(a)) * (po.list[o].size/2+15)
						if tile(math.floor(dx/32), math.floor(dy/32), "walkable") then
							if a==0 or a==180 or a==-180 then
								parse("setpos "..id.." "..player(id,"x").." "..dy)
							else
								parse("setpos "..id.." "..dx.." "..player(id,"y"))
							end
						end
					end
				end
			end
		end
	end
end

addhook("hitzone","po.hitzonePo")
function po.hitzonePo(img,id,obj,wpn,x,y,dmg)
	for o = 1, #po.list do
		if id > 0 and po.list[o].img == img then
			po.list[o].health = po.list[o].health - dmg
			if po.list[o].health > 0 then
				parse('sv_soundpos "'..po.list[o].breakingsound..'" '..po.list[o].x..' '..po.list[o].y) parse('sv_soundpos "'..po.list[o].breakingsound..'" '..po.list[o].x..' '..po.list[o].y) parse('sv_soundpos "'..po.list[o].breakingsound..'" '..po.list[o].x..' '..po.list[o].y)
				local pox, poy = po.list[o].x, po.list[o].y
				local a = -math.deg (math.atan2( x - pox, y - poy ) )
				local str = math.floor(dmg/20) if str<=0 then str=20 end
				local numb = str
				if a > -45 and a < 45 then a = 0 elseif a > 45 and a < 135 then a = 90 elseif a > 135 then a = 180 elseif a < - 45 and a > - 135 then a = -90 elseif a < - 135 then a = -180 end
				freetimer()
				function movePo()
					str = str - 1
					dx = po.list[o].x + math.sin(math.rad(a))
					dy = po.list[o].y - math.cos(math.rad(a))
					if tile(math.floor(dx/32), math.floor(dy/32), "walkable") then
						po.list[o].x = dx
						po.list[o].y = dy
						imagepos(po.list[o].imgs,po.list[o].x+3,po.list[o].y+3,0)
						imagepos(po.list[o].img,po.list[o].x,po.list[o].y,0)
					end
				end
				timer(1,"movePo","",numb)
			else
				parse('sv_soundpos "'..po.list[o].breakedsound..'" '..po.list[o].x..' '..po.list[o].y) parse('sv_soundpos "'..po.list[o].breakedsound..'" '..po.list[o].x..' '..po.list[o].y) parse('sv_soundpos "'..po.list[o].breakedsound..'" '..po.list[o].x..' '..po.list[o].y)
				freeimage(po.list[o].img)
				freeimage(po.list[o].imgs)
				if po.list[o].explode then
					parse("explosion "..po.list[o].x.." "..po.list[o].y.." "..po.list[o].exrange.." "..po.list[o].exdamage.." 0")
				end
			end
		end
	end
end